=== debian/changelog ===
arrayfire (3.3.2+dfsg1-4ubuntu1) yakkety; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Ignore autopkg test results, some random tests fail; not addressed upstream.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 22 Aug 2016 12:19:05 +0200

arrayfire (3.3.2+dfsg1-4) unstable; urgency=medium

  * Build with compute library from Boost 1.61.
  * d/rules: disable build of examples.
  * d/rules: remove superfluous nocheck guards.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 12 Aug 2016 13:05:13 +0100

arrayfire (3.3.2+dfsg1-3ubuntu1) yakkety; urgency=medium

  * Ignore autopkg test results, some random tests fail; not addressed upstream.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Aug 2016 18:51:59 +0200

arrayfire (3.3.2+dfsg1-3) unstable; urgency=medium

  * d/rules: fix test exclusion regex.
  * d/rules: drop usage of AF_INSTALL_INC_DIR flag.
  * d/rules: use relative paths for AF_INSTALL* flags.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 03 Aug 2016 12:37:55 +0100

arrayfire (3.3.2+dfsg1-2) unstable; urgency=medium

  * d/rules: disable imageio testcase.
  * Drop auto_clean override, use clean file instead.
  * d/rules: use DEB_HOST_ARCH_CPU instead of DEB_HOST_ARCH.
  * d/rules: minor fixes:
    - Add missing export command to DH_VERBOSE.
    - Use documented formatting for dpkg-architecture queries.
    - Use cleaner layout for comments regarding dh_auto_test.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 02 Aug 2016 15:32:57 +0100

arrayfire (3.3.2+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patch queue.
  * Bump standards version to 3.9.8, no changes required.
  * d/*.lintian-overrides: simplify regexes.
  * d/rules: simplify formatting.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 27 Apr 2016 00:35:08 +0100

arrayfire (3.3.1+dfsg1-2) unstable; urgency=medium

  * Refresh Fix-LAPACKE-detection.patch.
  * Add patch fixing FTBFS on hurd-i386.
  * d/rules: improve and simplify dh_auto_test override:
    - Replace explicit calls to ctest with dh_auto_test.
    - Enable running the testsuite in parallel.
    - Drop usage of explicit build directory.
  * Drop -dbg packages in favour of autogenerated -dbgsym.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 12 Apr 2016 16:32:59 +0100

arrayfire (3.3.1+dfsg1-1) unstable; urgency=medium

  * Release to unstable.
  * d/gbp.conf: use recommended packaging repository layout (DEP-14):
    - change upstream branch from dfsg-clean to upstream/latest.
    - change debian branch from debian/sid to debian/master.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 26 Mar 2016 15:52:53 +0000

arrayfire (3.3.1+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Refresh patch Fix-LAPACKE-detection.patch.
  * Update copyright information.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Mon, 21 Mar 2016 09:14:54 +0000

arrayfire (3.3.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * d/watch: add missing repacksuffix.
  * d/rules: build CPU backend without ASYNC support.
  * Update copyright information.
  * Bump standards version to 3.9.7, no changes required.
  * Add patch fixing LAPACKE detection.
  * d/t/control: add missing dependency on libarrayfire-unified-dev.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 02 Mar 2016 17:49:29 +0000

arrayfire (3.3~alpha+dfsg1-1) experimental; urgency=medium

  * New upstream release.
  * d/gbp.conf: use recommended DEP-14 format for upstream tags.
  * d/copyright: update list of files excluded after dfsg-cleaning.
  * Drop Always-use-freeimage-flags-instead-of-hardcoded-offsets.patch,
    fixed upstream.
  * d/rules: remove usage of deprecated BUILD_GTEST option.
  * cme fix d/control:
    - use secure VCS- Git URI.
    - remove unnecessary versioned depends.
    - sort install dependencies.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 05 Feb 2016 18:47:28 +0000
