=== debian/tests/control ===
Tests: build-examples
Depends: build-essential,
         cmake,
         libarrayfire-cpu-dev,
         libarrayfire-doc,
         libarrayfire-opencl-dev,
         libarrayfire-unified-dev
Restrictions: allow-stderr

Tests: build-testsuite
Depends: build-essential,
         cmake,
         libarrayfire-cpu-dev,
         libarrayfire-unified-dev,
         libgtest-dev
Restrictions: allow-stderr
