=== debian/watch ===
version=3
opts=dversionmangle=s/\+(debian|dfsg|ds|deb)(\d+)?$//,\
repacksuffix=+dfsg1,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/arrayfire-$1\.tar\.gz/ \
  https://github.com/arrayfire/arrayfire/tags .*/v?(\d\S*)\.tar\.gz
